diff --git a/src/test/default_collation/libc.utf8/t/001_default_collation.pl b/src/test/default_collation/libc.utf8/t/001_default_collation.pl
new file mode 100644
index 0000000000..e4b3552922
--- /dev/null
+++ b/src/test/default_collation/libc.utf8/t/001_default_collation.pl
@@ -0,0 +1,703 @@
+use strict;
+use warnings;
+
+use Config;
+use PostgresNode;
+use TestLib;
+use Test::More tests => 168;
+
+my $tempdir = TestLib::tempdir;
+my $datadir = "$tempdir/data";
+
+# test initdb
+
+sub test_initdb
+{
+	my ($test_name, $options, $error_message) = @_;
+	my ($in_initdb, $out_initdb, $err_initdb);
+
+	mkdir $datadir;
+
+	my @command = (qw(initdb -A trust -N -D), $datadir, split(" ", $options));
+	print "# Running: " . join(" ", @command) . "\n";
+	my $result = IPC::Run::run \@command, \$in_initdb, \$out_initdb,
+		\$err_initdb;
+
+	if ($error_message)
+	{
+		like($err_initdb,
+			 qr{$error_message},
+			 "initdb: $test_name: check error message");
+	}
+	else
+	{
+		ok($result, "\"@command\" exit code 0");
+		is($err_initdb, "", "\"@command\" no stderr");
+		like($out_initdb,
+			 qr{The default collation provider is \"libc\"\.},
+			 "initdb: $test_name: check output");
+	}
+
+	File::Path::rmtree $datadir;
+}
+
+sub psql
+{
+	my ($command, $db) = @_;
+	my ($result, $in, $out, $err);
+	my @psql = ('psql', '-X', '-c', $command);
+	if (defined($db))
+	{
+		push(@psql, $db);
+	}
+	print "# Running: " . join(" ", @psql) . "\n";
+	$result = IPC::Run::run \@psql, \$in, \$out, \$err;
+	($result, $out, $err);
+}
+
+# --locale
+
+test_initdb(
+	"be_BY\@latin libc locale",
+	"--locale=be_BY\@latin\@libc",
+	"");
+
+test_initdb(
+	"be_BY\@latin libc locale invalid modifier order",
+	"--locale=be_BY\@libc\@latin",
+	"invalid locale name \"be_BY\@libc\@latin\"");
+
+# --lc-collate
+
+test_initdb(
+	"be_BY\@latin libc lc_collate",
+	"--lc-collate=be_BY\@latin\@libc",
+	"");
+
+test_initdb(
+	"be_BY\@latin libc lc_collate invalid modifier order",
+	"--lc-collate=be_BY\@libc\@latin",
+	"invalid locale name \"be_BY\@libc\@latin\" \\(provider \"libc\"\\)");
+
+# test createdb, CREATE DATABASE and default collation behaviour
+
+sub test_createdb
+{
+	my ($test_name, $options, $from_template0, $error_message) = @_;
+	my (@command, $result, $in_command, $out_command, $err_command);
+
+	if ($from_template0)
+	{
+		$options = $options . " --template=template0";
+	}
+
+	@command = ("createdb", split(" ", $options), "mydb");
+	print "# Running: " . join(" ", @command) . "\n";
+	$result = IPC::Run::run \@command, \$in_command, \$out_command,
+		\$err_command;
+
+	if ($error_message)
+	{
+		like($err_command,
+			 qr{$error_message},
+			 "createdb: $test_name: check error message");
+	}
+	else
+	{
+		ok($result, "\"@command\" exit code 0");
+		is($err_command, "", "\"@command\" no stderr");
+
+		($result, $out_command, $err_command) = psql(
+			"select datcollate from pg_database where datname = 'mydb';");
+
+		like($out_command,
+			 qr{\@libc\n},
+			 "createdb: $test_name: check pg_database.datcollate");
+
+		@command = ("dropdb mydb");
+		print "# Running: " . join(" ", @command) . "\n";
+		system(@command);
+	}
+}
+
+sub test_create_database
+{
+	my ($test_name, $options, $from_template0, $error_message) = @_;
+	my (@command, $result, $in_command, $out_command, $err_command);
+
+	($result, $out_command, $err_command) = psql(
+				"create database mydb "
+			  . $options
+			  . ($from_template0 ? " TEMPLATE = template0;" : ";"));
+
+	if ($error_message)
+	{
+		like($err_command,
+			 qr{$error_message},
+			 "CREATE DATABASE: $test_name: check error message");
+	}
+	else
+	{
+		ok($result, "\"@command\" exit code 0");
+		is($err_command, "", "\"@command\" no stderr");
+		like($out_command, qr{CREATE DATABASE}, "\"@command\" check output");
+
+		($result, $out_command, $err_command) = psql(
+			"select datcollate from pg_database where datname = 'mydb';");
+
+		like($out_command,
+			 qr{\@libc\n},
+			 "CREATE DATABASE: $test_name: check pg_database.datcollate");
+
+		@command = ("dropdb mydb");
+		print "# Running: " . join(" ", @command) . "\n";
+		system(@command);
+	}
+}
+
+sub test_default_collation
+{
+	my ($createdb_options, $collation, @commands) = @_;
+	my (@command, $result, $in_command, $out_command, $err_command);
+
+	@command = ("createdb", split(" ", $createdb_options), "mydb");
+	print "# Running: " . join(" ", @command) . "\n";
+	$result = IPC::Run::run \@command, \$in_command, \$out_command,
+		\$err_command;
+
+	ok($result, "\"@command\" exit code 0");
+	is($err_command, "", "\"@command\" no stderr");
+
+	($result, $out_command, $err_command) = psql(
+		"select datcollate from pg_database where datname = 'mydb';");
+
+	like($out_command, qr{\@libc\n}, "\"@command\" check output");
+
+	for (my $row = 0; $row <= $#commands; $row++)
+	{
+		my ($command_text, $expected) = @{$commands[$row]};
+		($result, $out_command, $err_command) = psql($command_text, "mydb");
+
+		ok($result, "\"@command\" exit code 0");
+		is($err_command, "", "\"@command\" no stderr");
+		if ($out_command)
+		{
+			is(
+				$out_command,
+				$expected,
+				"default collation "
+			  . $collation
+			  . ": \""
+			  . $command_text
+			  . "\" check output");
+		}
+	}
+
+	@command = ("dropdb mydb");
+		print "# Running: " . join(" ", @command) . "\n";
+		system(@command);
+}
+
+my $node = get_new_node('main');
+$node->init;
+$node->start;
+local $ENV{PGPORT} = $node->port;
+
+# test createdb
+
+# --locale
+
+test_createdb(
+	"be_BY\@latin libc locale",
+	"--locale=be_BY\@latin\@libc",
+	1,
+	"");
+
+test_createdb(
+	"be_BY\@latin libc locale invalid modifier order",
+	"--locale=be_BY\@libc\@latin",
+	1,
+	"invalid locale name: \"be_BY\@libc\@latin\"");
+
+# --lc-collate
+
+test_createdb(
+	"be_BY\@latin libc lc_collate",
+	"--lc-collate=be_BY\@latin\@libc",
+	1,
+	"");
+
+test_createdb(
+	"be_BY\@latin libc lc_collate invalid modifier order",
+	"--lc-collate=be_BY\@libc\@latin",
+	1,
+	"invalid locale name: \"be_BY\@libc\@latin\" \\(provider \"libc\"\\)");
+
+# test CREATE DATABASE
+
+# LC_COLLATE
+
+test_create_database(
+	"be_BY\@latin libc lc_collate",
+	"LC_COLLATE = 'be_BY\@latin\@libc'",
+	1,
+	"");
+
+test_create_database(
+	"be_BY\@latin libc lc_collate invalid modifier order",
+	"LC_COLLATE = 'be_BY\@libc\@latin'",
+	1,
+	"invalid locale name: \"be_BY\@libc\@latin\" \\(provider \"libc\"\\)");
+
+# test default collation behaviour
+# use commands and outputs from the regression test collate.linux.utf8
+
+test_default_collation(
+	"--lc-collate=en_US.utf8\@libc --template=template0",
+	"en_US.utf8\@libc",
+	(
+		[
+			"CREATE TABLE collate_test1 (a int, b text NOT NULL);",
+			"CREATE TABLE\n"
+		],
+		[
+			"INSERT INTO collate_test1 VALUES "
+		  . "(1, 'abc'), (2, 'äbc'), (3, 'bbc'), (4, 'ABC');",
+			"INSERT 0 4\n"],
+		[
+			"SELECT * FROM collate_test1 WHERE b >= 'bbc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 3 | bbc\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, b FROM collate_test1 ORDER BY b;",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		# star expansion
+		[
+			"SELECT * FROM collate_test1 ORDER BY b;",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		# upper/lower
+		["CREATE TABLE collate_test10 (a int, x text);", "CREATE TABLE\n", ""],
+		[
+			"INSERT INTO collate_test10 VALUES (1, 'hij'), (2, 'HIJ');",
+			"INSERT 0 2\n"
+		],
+		[
+			"SELECT a, lower(x), upper(x), initcap(x) FROM collate_test10;",
+			" a | lower | upper | initcap \n"
+		  . "---+-------+-------+---------\n"
+		  . " 1 | hij   | HIJ   | Hij\n"
+		  . " 2 | hij   | HIJ   | Hij\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		# LIKE/ILIKE
+		[
+			"SELECT * FROM collate_test1 WHERE b LIKE 'abc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b LIKE 'abc%';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b LIKE '%bc%';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(3 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ILIKE 'abc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ILIKE 'abc%';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ILIKE '%bc%';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . " 4 | ABC\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT 'Türkiye' ILIKE '%KI%' AS \"true\";",
+			" true \n"
+		  . "------\n"
+		  . " t\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT 'bıt' ILIKE 'BIT' AS \"false\";",
+			" false \n"
+		  . "-------\n"
+		  . " f\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		# regular expressions
+		[
+			"SELECT * FROM collate_test1 WHERE b ~ '^abc\$';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ~ '^abc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ~ 'bc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(3 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ~* '^abc\$';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ~* '^abc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT * FROM collate_test1 WHERE b ~* 'bc';",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . " 4 | ABC\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		["CREATE TABLE collate_test6 (a int, b text);", "CREATE TABLE\n", ""],
+		[
+			"INSERT INTO collate_test6 VALUES "
+		  . "(1, 'abc'), (2, 'ABC'), (3, '123'), (4, 'ab1'), "
+		  . "(5, 'a1!'), (6, 'a c'), (7, '!.;'), (8, '   '), "
+		  . "(9, 'äbç'), (10, 'ÄBÇ');",
+			"INSERT 0 10\n"
+		],
+		[
+			"SELECT b, "
+		  . "b ~ '^[[:alpha:]]+\$' AS is_alpha, "
+		  . "b ~ '^[[:upper:]]+\$' AS is_upper, "
+		  . "b ~ '^[[:lower:]]+\$' AS is_lower, "
+		  . "b ~ '^[[:digit:]]+\$' AS is_digit, "
+		  . "b ~ '^[[:alnum:]]+\$' AS is_alnum, "
+		  . "b ~ '^[[:graph:]]+\$' AS is_graph, "
+		  . "b ~ '^[[:print:]]+\$' AS is_print, "
+		  . "b ~ '^[[:punct:]]+\$' AS is_punct, "
+		  . "b ~ '^[[:space:]]+\$' AS is_space "
+		  . "FROM collate_test6;",
+			"  b  | is_alpha | is_upper | is_lower | is_digit | is_alnum | is_graph | is_print | is_punct | is_space \n"
+		  . "-----+----------+----------+----------+----------+----------+----------+----------+----------+----------\n"
+		  . " abc | t        | f        | t        | f        | t        | t        | t        | f        | f\n"
+		  . " ABC | t        | t        | f        | f        | t        | t        | t        | f        | f\n"
+		  . " 123 | f        | f        | f        | t        | t        | t        | t        | f        | f\n"
+		  . " ab1 | f        | f        | f        | f        | t        | t        | t        | f        | f\n"
+		  . " a1! | f        | f        | f        | f        | f        | t        | t        | f        | f\n"
+		  . " a c | f        | f        | f        | f        | f        | f        | t        | f        | f\n"
+		  . " !.; | f        | f        | f        | f        | f        | t        | t        | t        | f\n"
+		  . "     | f        | f        | f        | f        | f        | f        | t        | f        | t\n"
+		  . " äbç | t        | f        | t        | f        | t        | t        | t        | f        | f\n"
+		  . " ÄBÇ | t        | t        | f        | f        | t        | t        | t        | f        | f\n"
+		  . "(10 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT 'Türkiye' ~* 'KI' AS \"true\";",
+			" true \n"
+		  . "------\n"
+		  . " t\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT 'bıt' ~* 'BIT' AS \"false\";",
+			" false \n"
+		  . "-------\n"
+		  . " f\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, lower(coalesce(x, 'foo')) FROM collate_test10;",
+			" a | lower \n"
+		  . "---+-------\n"
+		  . " 1 | hij\n"
+		  . " 2 | hij\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, b, greatest(b, 'CCC') FROM collate_test1 ORDER BY 3;",
+			" a |  b  | greatest \n"
+		  . "---+-----+----------\n"
+		  . " 1 | abc | CCC\n"
+		  . " 2 | äbc | CCC\n"
+		  . " 3 | bbc | CCC\n"
+		  . " 4 | ABC | CCC\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, x, lower(greatest(x, 'foo')) FROM collate_test10;",
+			" a |  x  | lower \n"
+		  . "---+-----+-------\n"
+		  . " 1 | hij | hij\n"
+		  . " 2 | HIJ | hij\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, nullif(b, 'abc') FROM collate_test1 ORDER BY 2;",
+			" a | nullif \n"
+		  . "---+--------\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . " 1 | \n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, lower(nullif(x, 'foo')) FROM collate_test10;",
+			" a | lower \n"
+		  . "---+-------\n"
+		  . " 1 | hij\n"
+		  . " 2 | hij\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, CASE b WHEN 'abc' THEN 'abcd' ELSE b END "
+		  . "FROM collate_test1 ORDER BY 2;",
+			" a |  b   \n"
+		  . "---+------\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 1 | abcd\n"
+		  . " 3 | bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		["CREATE DOMAIN testdomain AS text;", "CREATE DOMAIN\n", ""],
+		[
+			"SELECT a, b::testdomain FROM collate_test1 ORDER BY 2;",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, lower(x::testdomain) FROM collate_test10;",
+			" a | lower \n"
+		  . "---+-------\n"
+		  . " 1 | hij\n"
+		  . " 2 | hij\n"
+		  . "(2 rows)\n"
+		  . "\n"
+		],
+		[
+			"SELECT min(b), max(b) FROM collate_test1;",
+			" min | max \n"
+		  . "-----+-----\n"
+		  . " abc | bbc\n"
+		  . "(1 row)\n"
+		  . "\n",
+			""
+		],
+		[
+			"SELECT array_agg(b ORDER BY b) FROM collate_test1;",
+			"     array_agg     \n"
+		  . "-------------------\n"
+		  . " {abc,ABC,äbc,bbc}\n"
+		  . "(1 row)\n"
+		  . "\n"
+		],
+		[
+			"SELECT a, b FROM collate_test1 "
+		  . "UNION ALL "
+		  . "SELECT a, b FROM collate_test1 ORDER BY 2;",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . " 3 | bbc\n"
+		  . "(8 rows)\n"
+		  . "\n"
+		],
+		# casting
+		[
+			"SELECT a, CAST(b AS varchar) FROM collate_test1 ORDER BY 2;",
+			" a |  b  \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		# propagation of collation in SQL functions (inlined and non-inlined
+		# cases) and plpgsql functions too
+		[
+			"CREATE FUNCTION mylt (text, text) RETURNS boolean LANGUAGE sql "
+		  . "AS \$\$ select \$1 < \$2 \$\$;",
+			"CREATE FUNCTION\n"
+		],
+		[
+			"CREATE FUNCTION mylt_noninline (text, text) "
+		  . "RETURNS boolean LANGUAGE sql "
+		  . "AS \$\$ select \$1 < \$2 limit 1 \$\$;",
+			"CREATE FUNCTION\n"
+		],
+		[
+			"CREATE FUNCTION mylt_plpgsql (text, text) "
+		  . "RETURNS boolean LANGUAGE plpgsql "
+		  . "AS \$\$ begin return \$1 < \$2; end \$\$;",
+			"CREATE FUNCTION\n"
+		],
+		[
+			"SELECT a.b AS a, b.b AS b, a.b < b.b AS lt, "
+		  . "mylt(a.b, b.b), mylt_noninline(a.b, b.b), mylt_plpgsql(a.b, b.b) "
+		  . "FROM collate_test1 a, collate_test1 b "
+		  . "ORDER BY a.b, b.b;",
+			"  a  |  b  | lt | mylt | mylt_noninline | mylt_plpgsql \n"
+		  . "-----+-----+----+------+----------------+--------------\n"
+		  . " abc | abc | f  | f    | f              | f\n"
+		  . " abc | ABC | t  | t    | t              | t\n"
+		  . " abc | äbc | t  | t    | t              | t\n"
+		  . " abc | bbc | t  | t    | t              | t\n"
+		  . " ABC | abc | f  | f    | f              | f\n"
+		  . " ABC | ABC | f  | f    | f              | f\n"
+		  . " ABC | äbc | t  | t    | t              | t\n"
+		  . " ABC | bbc | t  | t    | t              | t\n"
+		  . " äbc | abc | f  | f    | f              | f\n"
+		  . " äbc | ABC | f  | f    | f              | f\n"
+		  . " äbc | äbc | f  | f    | f              | f\n"
+		  . " äbc | bbc | t  | t    | t              | t\n"
+		  . " bbc | abc | f  | f    | f              | f\n"
+		  . " bbc | ABC | f  | f    | f              | f\n"
+		  . " bbc | äbc | f  | f    | f              | f\n"
+		  . " bbc | bbc | f  | f    | f              | f\n"
+		  . "(16 rows)\n"
+		  . "\n"
+		],
+		# polymorphism
+		[
+			"SELECT * FROM unnest("
+		  . "(SELECT array_agg(b ORDER BY b) FROM collate_test1)"
+		  . ") ORDER BY 1;",
+			" unnest \n"
+		  . "--------\n"
+		  . " abc\n"
+		  . " ABC\n"
+		  . " äbc\n"
+		  . " bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		[
+			"CREATE FUNCTION dup (anyelement) RETURNS anyelement "
+		  . "AS 'select \$1' LANGUAGE sql;",
+			"CREATE FUNCTION\n"
+		],
+		[
+			"SELECT a, dup(b) FROM collate_test1 ORDER BY 2;",
+			" a | dup \n"
+		  . "---+-----\n"
+		  . " 1 | abc\n"
+		  . " 4 | ABC\n"
+		  . " 2 | äbc\n"
+		  . " 3 | bbc\n"
+		  . "(4 rows)\n"
+		  . "\n"
+		],
+		# indexes
+		[
+			"CREATE INDEX collate_test1_idx1 ON collate_test1 (b);",
+			"CREATE INDEX\n"
+		]
+	)
+);
+
+$node->stop;
diff --git a/src/test/default_collation/libc/Makefile b/src/test/default_collation/libc/Makefile
new file mode 100644
index 0000000000..98ab736d7a
--- /dev/null
+++ b/src/test/default_collation/libc/Makefile
@@ -0,0 +1,11 @@
+# src/test/default_collation/libc/Makefile
+
+subdir = src/test/default_collation/libc
+top_builddir = ../../../..
+include $(top_builddir)/src/Makefile.global
+
+check:
+	$(prove_check)
+
+clean distclean maintainer-clean:
+	rm -rf tmp_check
diff --git a/src/test/default_collation/libc/t/001_default_collation.pl b/src/test/default_collation/libc/t/001_default_collation.pl
new file mode 100644
index 0000000000..bc8a6ad02c
--- /dev/null
+++ b/src/test/default_collation/libc/t/001_default_collation.pl
@@ -0,0 +1,355 @@
+use strict;
+use warnings;
+
+use Config;
+use PostgresNode;
+use TestLib;
+use Test::More tests => 90;
+
+my $tempdir = TestLib::tempdir;
+my $datadir = "$tempdir/data";
+
+# test initdb
+
+sub test_initdb
+{
+	my ($test_name, $options, $error_message) = @_;
+	my ($in_initdb, $out_initdb, $err_initdb);
+
+	mkdir $datadir;
+
+	my @command = (qw(initdb -A trust -N -D), $datadir, split(" ", $options));
+	print "# Running: " . join(" ", @command) . "\n";
+	my $result = IPC::Run::run \@command, \$in_initdb, \$out_initdb,
+		\$err_initdb;
+
+	if ($error_message)
+	{
+		like($err_initdb,
+			 qr{$error_message},
+			 "initdb: $test_name: check error message");
+	}
+	else
+	{
+		ok($result, "\"@command\" exit code 0");
+		is($err_initdb, "", "\"@command\" no stderr");
+		like($out_initdb,
+			 qr{The default collation provider is \"libc\"\.},
+			 "initdb: $test_name: check output");
+	}
+
+	File::Path::rmtree $datadir;
+}
+
+# empty locales
+
+test_initdb(
+	"empty locales",
+	"",
+	"");
+
+# --locale
+
+test_initdb(
+	"empty libc locale",
+	"--locale=\@libc",
+	"");
+
+test_initdb(
+	"C locale without collation provider",
+	"--locale=C",
+	"");
+
+test_initdb(
+	"POSIX locale without collation provider",
+	"--locale=POSIX",
+	"");
+
+test_initdb(
+	"C libc locale",
+	"--locale=C\@libc",
+	"");
+
+test_initdb(
+	"C icu locale",
+	"--locale=C\@icu",
+	"ICU is not supported in this build");
+
+test_initdb(
+	"C locale too many modifiers",
+	"--locale=C\@icu\@libc",
+	"invalid locale name \"C\@icu\"");
+
+# --lc-collate
+
+test_initdb(
+	"empty libc lc_collate",
+	"--lc-collate=\@libc",
+	"");
+
+test_initdb(
+	"C lc_collate without collation provider",
+	"--lc-collate=C",
+	"");
+
+test_initdb(
+	"POSIX lc_collate without collation provider",
+	"--lc-collate=POSIX",
+	"");
+
+test_initdb(
+	"C libc lc_collate",
+	"--lc-collate=C\@libc",
+	"");
+
+test_initdb(
+	"C icu lc_collate",
+	"--lc-collate=C\@icu",
+	"ICU is not supported in this build");
+
+test_initdb(
+	"C lc_collate too many modifiers",
+	"--lc-collate=C\@icu\@libc",
+	"invalid locale name \"C\@icu\" \\(provider \"libc\"\\)");
+
+# --locale & --lc-collate
+
+test_initdb(
+	"lc_collate implicit provider takes precedence",
+	"--locale=\@icu --lc-collate=C",
+	"");
+
+test_initdb(
+	"lc_collate explicit provider takes precedence",
+	"--locale=\@icu --lc-collate=\@libc",
+	"");
+
+# test createdb and CREATE DATABASE
+
+sub test_createdb
+{
+	my ($test_name, $options, $from_template0, $error_message) = @_;
+	my (@command, $result, $in_command, $out_command, $err_command);
+
+	if ($from_template0)
+	{
+		$options = $options . " --template=template0";
+	}
+
+	@command = ("createdb", split(" ", $options), "mydb");
+	print "# Running: " . join(" ", @command) . "\n";
+	$result = IPC::Run::run \@command, \$in_command, \$out_command,
+		\$err_command;
+
+	if ($error_message)
+	{
+		like($err_command,
+			 qr{$error_message},
+			 "createdb: $test_name: check error message");
+	}
+	else
+	{
+		ok($result, "\"@command\" exit code 0");
+		is($err_command, "", "\"@command\" no stderr");
+
+		@command = (
+			"psql",
+			"-c",
+			"select datcollate from pg_database where datname = 'mydb';");
+		print "# Running: " . join(" ", @command) . "\n";
+		$result = IPC::Run::run \@command, \$in_command, \$out_command,
+			\$err_command;
+
+		like($out_command,
+			 qr{\@libc\n},
+			 "createdb: $test_name: check pg_database.datcollate");
+
+		@command = ("dropdb mydb");
+		print "# Running: " . join(" ", @command) . "\n";
+		system(@command);
+	}
+}
+
+sub test_create_database
+{
+	my ($test_name, $options, $from_template0, $error_message) = @_;
+	my (@command, $result, $in_command, $out_command, $err_command);
+
+	@command = ("psql",
+				"-c",
+				"create database mydb "
+			  . $options
+			  . ($from_template0 ? " template = template0" : "")
+			  . ";");
+	print "# Running: " . join(" ", @command) . "\n";
+	$result = IPC::Run::run \@command, \$in_command, \$out_command,
+		\$err_command;
+
+	if ($error_message)
+	{
+		like($err_command,
+			 qr{$error_message},
+			 "CREATE DATABASE: $test_name: check error message");
+	}
+	else
+	{
+		ok($result, "\"@command\" exit code 0");
+		is($err_command, "", "\"@command\" no stderr");
+		like($out_command, qr{CREATE DATABASE}, "\"@command\" check output");
+
+		@command = (
+			"psql",
+			"-c",
+			"select datcollate from pg_database where datname = 'mydb';");
+		print "# Running: " . join(" ", @command) . "\n";
+		$result = IPC::Run::run \@command, \$in_command, \$out_command,
+			\$err_command;
+
+		like($out_command,
+			 qr{\@libc\n},
+			 "CREATE DATABASE: $test_name: check pg_database.datcollate");
+
+		@command = ("dropdb mydb");
+		print "# Running: " . join(" ", @command) . "\n";
+		system(@command);
+	}
+}
+
+my $node = get_new_node('main');
+$node->init;
+$node->start;
+local $ENV{PGPORT} = $node->port;
+
+# test createdb
+
+# empty locales
+
+test_createdb(
+	"empty locales",
+	"",
+	0,
+	"");
+
+# --locale
+
+test_createdb(
+	"empty libc locale",
+	"--locale=\@libc",
+	0,
+	"");
+
+test_createdb(
+	"C locale without collation provider",
+	"--locale=C",
+	1,
+	"");
+
+test_createdb(
+	"POSIX locale without collation provider",
+	"--locale=POSIX",
+	1,
+	"");
+
+test_createdb(
+	"C libc locale",
+	"--locale=C\@libc",
+	1,
+	"");
+
+test_createdb(
+	"C icu locale",
+	"--locale=C\@icu",
+	1,
+	"ICU is not supported in this build");
+
+test_createdb(
+	"C locale too many modifiers",
+	"--locale=C\@icu\@libc",
+	1,
+	"invalid locale name: \"C\@icu\"");
+
+# --lc-collate
+
+test_createdb(
+	"empty libc lc_collate",
+	"--lc-collate=\@libc",
+	0,
+	"");
+
+test_createdb(
+	"C lc_collate without collation provider",
+	"--lc-collate=C",
+	1,
+	"");
+test_createdb(
+	"POSIX lc_collate without collation provider",
+	"--lc-collate=POSIX",
+	1,
+	"");
+
+test_createdb(
+	"C libc lc_collate",
+	"--lc-collate=C\@libc",
+	1,
+	"");
+
+test_createdb(
+	"C icu lc_collate",
+	"--lc-collate=C\@icu",
+	1,
+	"ICU is not supported in this build");
+
+test_createdb(
+	"C lc_collate too many modifiers",
+	"--lc-collate=C\@icu\@libc",
+	1,
+	"invalid locale name: \"C\@icu\" \\(provider \"libc\"\\)");
+
+# test CREATE DATABASE
+
+# empty locales
+
+test_create_database(
+	"empty locales",
+	"",
+	0,
+	"");
+
+# LC_COLLATE
+
+test_create_database(
+	"empty libc lc_collate",
+	"LC_COLLATE = '\@libc'",
+	0,
+	"");
+
+test_create_database(
+	"C lc_collate without collation provider",
+	"LC_COLLATE = 'C'",
+	1,
+	"");
+test_create_database(
+	"POSIX lc_collate without collation provider",
+	"LC_COLLATE = 'POSIX'",
+	1,
+	"");
+
+test_create_database(
+	"C libc lc_collate",
+	"LC_COLLATE = 'C\@libc'",
+	1,
+	"");
+
+test_create_database(
+	"C icu lc_collate",
+	"LC_COLLATE = 'C\@icu'",
+	1,
+	"ICU is not supported in this build");
+
+test_create_database(
+	"C lc_collate too many modifiers",
+	"LC_COLLATE = 'C\@icu\@libc'",
+	1,
+	"invalid locale name: \"C\@icu\" \\(provider \"libc\"\\)");
+
+$node->stop;
diff --git a/src/test/regress/sql/collate.icu.utf8.sql b/src/test/regress/sql/collate.icu.utf8.sql
index ef39445b30..936d684e10 100644
--- a/src/test/regress/sql/collate.icu.utf8.sql
+++ b/src/test/regress/sql/collate.icu.utf8.sql
@@ -339,18 +339,22 @@ SELECT relname, pg_get_indexdef(oid) FROM pg_class WHERE relname LIKE 'collate_t
 CREATE ROLE regress_test_role;
 CREATE SCHEMA test_schema;
 
+-- remove provider modifier and collation version
+CREATE FUNCTION get_lc_collate (text) RETURNS text LANGUAGE sql
+    AS $$ select substring($1 from '(.*)@[^@]+$') $$;
+
 -- We need to do this this way to cope with varying names for encodings:
 do $$
 BEGIN
   EXECUTE 'CREATE COLLATION test0 (provider = icu, locale = ' ||
-          quote_literal(current_setting('lc_collate')) || ');';
+          quote_literal(get_lc_collate(current_setting('lc_collate'))) || ');';
 END
 $$;
 CREATE COLLATION test0 FROM "C"; -- fail, duplicate name
 do $$
 BEGIN
   EXECUTE 'CREATE COLLATION test1 (provider = icu, lc_collate = ' ||
-          quote_literal(current_setting('lc_collate')) ||
+          quote_literal(get_lc_collate(current_setting('lc_collate'))) ||
           ', lc_ctype = ' ||
           quote_literal(current_setting('lc_ctype')) || ');';
 END
diff --git a/src/test/regress/sql/collate.linux.utf8.sql b/src/test/regress/sql/collate.linux.utf8.sql
index b51162e3a1..e03ea1bde1 100644
--- a/src/test/regress/sql/collate.linux.utf8.sql
+++ b/src/test/regress/sql/collate.linux.utf8.sql
@@ -339,11 +339,15 @@ SELECT relname, pg_get_indexdef(oid) FROM pg_class WHERE relname LIKE 'collate_t
 CREATE ROLE regress_test_role;
 CREATE SCHEMA test_schema;
 
+-- remove provider modifier and collation version
+CREATE FUNCTION get_lc_collate (text) RETURNS text LANGUAGE sql
+    AS $$ select substring($1 from '(.*)@[^@]+$') $$;
+
 -- We need to do this this way to cope with varying names for encodings:
 do $$
 BEGIN
   EXECUTE 'CREATE COLLATION test0 (locale = ' ||
-          quote_literal(current_setting('lc_collate')) || ');';
+          quote_literal(get_lc_collate(current_setting('lc_collate'))) || ');';
 END
 $$;
 CREATE COLLATION test0 FROM "C"; -- fail, duplicate name
@@ -352,7 +356,7 @@ CREATE COLLATION IF NOT EXISTS test0 (locale = 'foo'); -- ok, skipped
 do $$
 BEGIN
   EXECUTE 'CREATE COLLATION test1 (lc_collate = ' ||
-          quote_literal(current_setting('lc_collate')) ||
+          quote_literal(get_lc_collate(current_setting('lc_collate'))) ||
           ', lc_ctype = ' ||
           quote_literal(current_setting('lc_ctype')) || ');';
 END
diff --git a/src/tools/msvc/Mkvcbuild.pm b/src/tools/msvc/Mkvcbuild.pm
index 59bed3b8a8..a5bf7e1703 100644
--- a/src/tools/msvc/Mkvcbuild.pm
+++ b/src/tools/msvc/Mkvcbuild.pm
@@ -51,12 +51,19 @@ my @contrib_excludes = (
 	'snapshot_too_old');
 
 # Set of variables for frontend modules
-my $frontend_defines = { 'initdb' => 'FRONTEND' };
+my $frontend_defines = {
+	'initdb'     => 'FRONTEND',
+	'psql'       => 'FRONTEND',
+	'pg_dump'    => 'FRONTEND',
+        'pg_dumpall' => 'FRONTEND',
+        'pg_restore' => 'FRONTEND',
+	};
 my @frontend_uselibpq = ('pg_ctl', 'pg_upgrade', 'pgbench', 'psql', 'initdb');
 my @frontend_uselibpgport = (
 	'pg_archivecleanup', 'pg_test_fsync',
 	'pg_test_timing',    'pg_upgrade',
 	'pg_waldump',        'pgbench');
+my @iculibs = ('icuin.lib', 'icuuc.lib');
 my @frontend_uselibpgcommon = (
 	'pg_archivecleanup', 'pg_test_fsync',
 	'pg_test_timing',    'pg_upgrade',
@@ -65,8 +72,10 @@ my $frontend_extralibs = {
 	'initdb'     => ['ws2_32.lib'],
 	'pg_restore' => ['ws2_32.lib'],
 	'pgbench'    => ['ws2_32.lib'],
+	'mchar'		 => [@iculibs],
 	'psql'       => ['ws2_32.lib']
 };
+my @frontend_iculibs = ('initdb', 'pg_upgrade');
 my $frontend_extraincludes = {
 	'initdb' => ['src/timezone'],
 	'psql'   => ['src/backend']
@@ -117,7 +126,7 @@ sub mkvcbuild
 
 	our @pgcommonallfiles = qw(
 	  base64.c config_info.c controldata_utils.c exec.c file_perm.c ip.c
-	  keywords.c link-canary.c md5.c
+	  keywords.c link-canary.c md5.c pg_collation_fn_common.c
 	  pg_lzcompress.c pgfnames.c psprintf.c relpath.c rmtree.c
 	  saslprep.c scram-common.c string.c unicode_norm.c username.c
 	  wait_error.c);
@@ -152,6 +161,7 @@ sub mkvcbuild
 	$libpgfeutils->AddDefine('FRONTEND');
 	$libpgfeutils->AddIncludeDir('src/interfaces/libpq');
 	$libpgfeutils->AddFiles('src/fe_utils', @pgfeutilsfiles);
+	$libpgfeutils->AddFile('src/common/pg_collation_fn_common.c');
 
 	$postgres = $solution->AddProject('postgres', 'exe', '', 'src/backend');
 	$postgres->AddIncludeDir('src/backend');
@@ -233,6 +243,7 @@ sub mkvcbuild
 		'src/interfaces/libpq');
 	$libpq->AddDefine('FRONTEND');
 	$libpq->AddDefine('UNSAFE_STAT_OK');
+	$libpq->AddDefine('LIBPQ_MAKE');
 	$libpq->AddIncludeDir('src/port');
 	$libpq->AddLibrary('secur32.lib');
 	$libpq->AddLibrary('ws2_32.lib');
@@ -241,6 +252,7 @@ sub mkvcbuild
 	$libpq->ReplaceFile('src/interfaces/libpq/libpqrc.c',
 		'src/interfaces/libpq/libpq.rc');
 	$libpq->AddReference($libpgcommon, $libpgport);
+	$libpq->AddFile('src/common/pg_collation_fn_common.c');
 
 	# The OBJS scraper doesn't know about ifdefs, so remove appropriate files
 	# if building without OpenSSL.
@@ -419,6 +431,12 @@ sub mkvcbuild
 	{
 		push @contrib_excludes, 'uuid-ossp';
 	}
+	else
+	{
+		foreach my $fe (@frontend_iculibs) {
+			push @{$frontend_extralibs->{$fe}}, @iculibs;
+		}
+	}
 
 	# AddProject() does not recognize the constructs used to populate OBJS in
 	# the pgcrypto Makefile, so it will discover no files.
-- 
2.17.1 (Apple Git-112)

